/*****ADC****/
#include "MC32P8141.h"
#include "define.h"
#include "Global.h"
uint8_t ADC_Zero_ADJ(void);
uint ADC_Get_Value_Average(u8 CHX);
u8  gBadc_loop;
u16 __at 0x1f gWadc_value;
u16 gWadc_value_max;
u16 gWadc_value_min;
/************************************************
;  *    @Function Name       : ADC_Zero_ADJ
;  *    @Description         : ADCУ׼
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    : 0 У׼ɹ  1У׼ʧ
;  ***********************************************/
uint8_t ADC_Zero_ADJ(void)
{
    gBadc_loop = 100;

    while(gBadc_loop--){
   	   	__asm
   	   	CLRWDT
   	   	__endasm;
        while(!T0IF);
            T0IF = 0; 
    }

   	OSADJCR = 0x80;
   	ADC_Get_Value_Average(GND);  //gWadc_value
   	if(gWadc_value>0)
   	{
loopcheck1:
   	   	OSADJCR++;
   	   	ADC_Get_Value_Average(GND);
   	   	if((OSADJCR&0x0f)==0x0f){
   	   	   	}
   	   	else{
   	   	   	if(gWadc_value!=0)
   	   	   	   	goto   	loopcheck1;
   	   	} 
   	}
   	else
   	{
   	   	OSADJCR	=  	0xff;
loopcheck2:
   	   	ADC_Get_Value_Average(GND);
   	   	if((OSADJCR&0x0f)==0x00){
   	   	   	}
   	   	else{
   	   	   	if(gWadc_value!=0)
   	   	   	{
   	   	   	   	OSADJCR--;
   	   	   	   	goto   	loopcheck2;
   	   	   	}
   	   	}  	
   	}
   	//У׼ֵλ
   	__asm
   	movar  	   	OSADJCR
   	movra  	   	0x71   	   	
   	__endasm;  	   	
   	
}
/************************************************
;  *    @Function Name       : ADC_Get_Value_Average
;  *    @Description         : ת
;  *    @IN_Parameter      	 : ͨ
;  *    @Return parameter    : ADCֵ
   	   	ռڴϴ180+ֽڣ
 *	лͨⲿӰ죬ǰתĽ
;  ***********************************************/

uint ADC_Get_Value_Average(u8 CHX)
{
   	   	unsigned int gWadc_data;

   	   	ADCR0  	&= 	0xf0;
   	   	ADCR0  	|= 	CHX;
   	   	gBadc_loop 	=  	8;
   	   	while(gBadc_loop){
   	   	   	ADEOC  	=  	0;
   	   	   	while (!ADEOC);
   	   	   	   	// ADRL
   	   	   	   	gBadc_loop--;
   	   	   	   	gWadc_data = ADRH;
   	   	   	   	gWadc_data <<=8;
   	   	   	   	gWadc_data 	|= ADRL;
   	   	   	   	if (gBadc_loop>=5)
   	   	   	   	{
   	   	   	   	   	
   	   	   	   	   	gWadc_value = gWadc_data;
   	   	   	   	   	gWadc_value_max = gWadc_data;
   	   	   	   	   	gWadc_value_min = gWadc_data;
   	   	   	   	   	
   	   	   	   	}
   	   	   	   	else
   	   	   	   	{
   	   	   	   	   	gWadc_value	+= 	gWadc_data;
   	   	   	   	   	if(gWadc_value_max<gWadc_data)
   	   	   	   	   	   	gWadc_value_max = gWadc_data;
   	   	   	   	   	if(gWadc_value_min>gWadc_data)
   	   	   	   	   	   	gWadc_value_min = gWadc_data;
   	   	   	   	}  	   	   	   	   	   	   	   	   	   	   	   	   	   	
   	   	}
   	   	gWadc_value -= gWadc_value_max;
   	   	gWadc_value -= gWadc_value_min;
        gWadc_value>>=2;   	   	
}
