#include "MC32P8141.h"
#include "define.h"
#include "Global.h"
u8 gBleft;
u8 gBLOADIN_L;          //
u8 gBleft_FULL_CNT;
u8 gBOvercurrent_L;       //
u8 gBShort_circuit_L;     //·
u8 left_Remove;
u8 gBleft_cnt;
u8 gBlflash;
u8 left_PLUSE_NUM;        //
u8 left_PLUSE_TIME;

void  left_Detect (void);
void left_ADC_Detect(void);
void  Check_L_EAR_IN(void);
void    L_EAR_WORK_CHECK(void);
void    L_EAR_MAY_FULL_CHECK(void);
void  Check_L_EAR_OUT(void);

/**********״̬*************/
void  left_Detect (void)
{
    LEAR_ON = 0; 
    LEAR_OUT = 0;   
    if(gB500MS_cnt==0)
        ADC_Get_Value_Average(9);  //gWadc_value      AN9
    //bat_low_off_flag = 1;
    //bat_low_tip_flag = 1;   
    //gWadc_value = 100;
    switch(gBleft)                    //ж϶Ƿڲ֣0
    {
        case 0:                     //ڲ
        Check_L_EAR_IN();
        break;
        case 1:                     //ڲ
        if(gB500MS_cnt==0)
            L_EAR_WORK_CHECK();
        
        if(bat_low_off_flag){
            if(USB_STATUS==0)
                gBleft=6;
        }
        break;
        case 2:                     //ڲ֣
        L_EAR_MAY_FULL_CHECK();
        
        break;
        case 3:                     //ڲ֣
        Check_L_EAR_OUT();
        if(USB_ON)
            gBleft = 1;
        break;
        case 4:                     //ڲ֣·
        Check_L_EAR_OUT();
        break;
        case 5:                   
       
        
        break;
        case 6:                     //͵ػֹͣ
        Check_L_EAR_OUT();
        if(USB_ON)
            gBleft = 1;
        break;
    }

    switch(gBleft)                    //ж϶Ƿڲ֣0
    {
        case 0:
        NMOS0ON=0;                  //0mosأ
 
        break;
        case 1:
        gBSTOP_cnt =0;  //
        NMOS0ON=1;                  //1mos
        if(LEAR_ON){
            gBEAR_MOVE_CNT = 1000;
        }
        break;
        case 2:
        NMOS0ON=0;

        break;
        case 3:
        NMOS0ON=0;

        break;
        case 4:
        NMOS0ON=0;

        break;
        case 5:
       
        break;
        case 6:                     //͵ػ
        NMOS0ON=0;  
        break;
    }
    __asm
   	movar  	   	_gBleft
   	movra  	   	0x78   	   	
    movar  	   	0x20
   	movra  	   	0x79
    movar  	   	0x1f
   	movra  	   	0x7a
   	__endasm;
    
}


void    Check_L_EAR_IN(void){
    if(P00D==1)
        {
            gBLOADIN_L++;
            gBSTOP_cnt =0;  //
            if(gBLOADIN_L>50)         //
            {
                gBLOADIN_L=0;
                 gBleft=1;             //ڲ
                 LEAR_ON = 1; 
            }
        }
        else 
        {
   	   	   	gBLOADIN_L=0;
            left_ON=0;
   	   	}
}

void    L_EAR_WORK_CHECK(void){
        left_ON=1;                  //ڲֱ־λһ
        //ADC_Get_Value_Average(9);  //gWadc_value      AN9
        if(gWadc_value<CUR_7MA){
            gBLOADIN_L++;
            if(gBLOADIN_L>50){
                gBLOADIN_L=0;
                gBleft = 2;             //
                left_keep_check = 1;
            }
        }
        else{
            gBLOADIN_L=0;
        }
        //·
        if(gWadc_value>CUR_150MA)
        {
            gBOvercurrent_L++;
            if(gBOvercurrent_L>250){
                gBOvercurrent_L=0;
                gBleft = 3;             //
            }
        }
        else{
            gBOvercurrent_L = 0;
        }
        if(gWadc_value>CUR_300MA){
            
                gBShort_circuit_L++;
                if(gBShort_circuit_L>100)
                {
                    gBShort_circuit_L=0;
                    gBleft = 4;             //·
                }
        }
        else{
                gBShort_circuit_L = 0;
        }
}
void    L_EAR_MAY_FULL_CHECK(void){
        if(left_keep_check){
            gBSTOP_cnt =0;  //
            if(L_EAR_IO==0){
                gBleft_FULL_CNT = 0;
                gBleft_cnt++;
                if(gBleft_cnt>left_shake_data)
                {
                    gBleft_cnt=0;
                       
                    left_keep_check=0;
                    LEAR_OUT = 1; //
                    gBleft=0;
                }
            }
            else{
                gBleft_cnt = 0;
                gBleft_FULL_CNT++;
                 if(gBleft_FULL_CNT>left_shake_data)
                {
                  gBleft_FULL_CNT = 0;
                  left_FULL=1;          //
                  left_keep_check=0;
                }
                        
            }
            
        }
        else{
            if(L_EAR_IO==0){
                gBleft_cnt++;
                gBSTOP_cnt =0;  //
                if(gBleft_cnt>left_shake_data)
                {
                    gBleft_cnt=0;      //
                    LEAR_OUT = 1;
                    left_keep_check=0;
                    gBleft=0;
                }
            }
            else{
                gBleft_cnt = 0;
            }
        }
}
void  Check_L_EAR_OUT(void){
     if(L_EAR_IO==0){
        gBleft_cnt++;
        gBSTOP_cnt =0;  //
        if(gBleft_cnt>left_shake_data)
        {
            gBleft_cnt=0;
            left_Remove=1;      //
            left_keep_check=0;
            gBleft=0;
        }
    }
    else{
        gBleft_cnt = 0;
     }
}
