/****ص******/
#include "MC32P8141.h"
#include "define.h"
#include "Global.h"

u8 gBBAT_Work;
u8 gBBAT_mode;
u8  gBBAT_LEVEL;
u8  gBBAT_LEVEL_WAIT;
u16  gWBAT_ADC_VALUE;
u8  gBBAT_ADC_VALUE_CNT; 
u8  gBLEVEL_CNT;
void BAT_LEVEL_SET_UC(void);
void BAT_LEVEL_SET_C(void);
void BAT(void);
void BAT_LEVEL_CHECK(void);
//ѹӦ
unsigned int   const TAB_BAT_VALUE[]={

    0x0666,    	//3.2
   	0x06CC,    	//3.4-----5%   	    
    0x0770,    	//3.72V--25%     
    0x07A3,    	//3.82V--50%
   	0x07F0,    	//3.97V--75%       2/3---------4
    0x0866 	    //4.2V   
};

void BAT(void){
    gBLED_DATA_BUF = 0;     //LEDʾ
    gBLED_FLASH_BUF.byte = 0;    //LED˸
    if(gB500MS_cnt==0)
        ADC_Get_Value_Average(0x0e);    //gWadc_value   ɵصѹ  ͨAN14
    
    switch (gBBAT_Work){
        case 0:
        if(USB_ON==1){
            gBBAT_Work=1;       //usb 
            gBBAT_mode=5;
            
        }
        break;
        case 1:
        if(USB_OFF==1){
            gBBAT_Work=0;       //usb 
            gBBAT_mode=5;
        }
        if(BAT_FUll==1){
            gBBAT_Work=2;       //س
        }
        break;

        case 2:
        if(USB_OFF==1)
        {
            gBBAT_Work=0;       //س 
        }
        if(BAT_Recharge==1)
        {
            gBBAT_Work=1;
        }
        break;
    }
    switch (gBBAT_Work)
    {
        case 0:
        if(gB500MS_cnt==0)
            BAT_LEVEL_SET_UC();     //ǳ״̬µȼ趨
        break;

        case 1:
        gBSTOP_cnt = 0;         //0
        if(gB500MS_cnt==0)
            BAT_LEVEL_SET_C();      //״̬µȼ趨
        break;

        case 2:
        gBSTOP_cnt = 0;         //0
        gBLED_DATA_BUF = 0x0f;
        break;  
    }
    if((USB_ON)||(USB_OFF)){
        gWBAT_ADC_VALUE = 0;
        gBBAT_ADC_VALUE_CNT = 0;
    }
    //λ
    __asm
	movar		_gBBAT_Work
	movra		0x72		
    movar		0x20
	movra		0x73
    movar		0x1f
	movra		0x74
	__endasm;
    //0x1f0x20λΪADCƽֵĵλ͸λ
    //λ
}
//---ȼ趨
//25%50%75%
void BAT_LEVEL_SET_UC(void){
    BAT_LEVEL_CHECK();
    if (gBBAT_ADC_VALUE_CNT)
        return;
    
        //ȼ
        if (gBBAT_LEVEL_WAIT<gBBAT_LEVEL)       //ʱжڵصѹǷС֮ǰصѹ  ֹĵѹ
        {
           gBLEVEL_CNT++;
           if(gBLEVEL_CNT>30){
               gBLEVEL_CNT = 0;
               gBBAT_LEVEL = gBBAT_LEVEL_WAIT;
           }
        }
        else
        {
            gBLEVEL_CNT = 0;
        }
        if(gBBAT_LEVEL==0)
            bat_low_off_flag    =   1;  //͵ػ5V־  
        if(gBBAT_LEVEL<=1)  
            bat_low_tip_flag    =   1;  //͵ʾѳ־                
    
    
}
void BAT_LEVEL_SET_C(void){
     BAT_LEVEL_CHECK();
     if (gBBAT_ADC_VALUE_CNT)
        return;
    //ȼ
        if (gBBAT_LEVEL_WAIT>gBBAT_LEVEL)       //ʱж֮ǰصѹǷСڵصѹ  ֹĵѹ
        {
           gBLEVEL_CNT++;
           if(gBLEVEL_CNT>30){
               gBLEVEL_CNT = 0;
               gBBAT_LEVEL = gBBAT_LEVEL_WAIT;
           }
        }
        else
        {
            gBLEVEL_CNT = 0;
        }
        if(gBBAT_LEVEL>0)
            bat_low_off_flag    =   0;  //͵ػ5V־   
        if(gBBAT_LEVEL>1)  
            bat_low_tip_flag    =   0;  //͵ʾѳ־       
}
void BAT_LEVEL_CHECK(void){
   	u8 gBmode;
    gWBAT_ADC_VALUE += gWadc_value;
    gBBAT_ADC_VALUE_CNT++; 
    if(gBBAT_ADC_VALUE_CNT>=8){
        gBBAT_ADC_VALUE_CNT = 0;
        gWBAT_ADC_VALUE >>= 3;
        gBmode = 0;
READ_LOOP:
        gWadc_value_max = TAB_BAT_VALUE[gBmode];  //gWadc_value_max䵱ֲ
        if(gWBAT_ADC_VALUE>gWadc_value_max){
            gBmode++;
            if(gBmode<5)
                goto    READ_LOOP;   //
      
        }
        gBBAT_LEVEL_WAIT = gBmode;
        gWBAT_ADC_VALUE = 0;
    }
}