/******************************************************************************
;  *   	@MCU   	   	   	   	 : MC9931
;  *   	@Create Date         : 2020.03.27
;  *   	@Author/Corporation  : Martin/SinoMCU
;  *   	@΢֧QQȺ   : 814641858
;  *    @΢ٷ̳       : http://bbs.sinomcu.com/
;  *   	@Copyright           : 2020 SINOMCU Corporation,All Rights Reserved.
;  *    ʹõоƬƽ̨ MC32P8141 
;  *----------------------Abstract Description---------------------------------
;  *   	   	   	             ADC
                     
    ʹ ADC ģӳ 500ms ϣлοѹӳ 200us ϣ·ȶ AD ת
++        лͨⲿӰ죬ǰתĽ
******************************************************************************/

#include "MC32P8141.h"
#include "define.h"
#include "Global.h"

unsigned char   abuf;
unsigned char   statusbuf;
unsigned char   i;
unsigned char   gBTime_2S_cnt;

volatile bit_flag flag1;
volatile bit_flag flag2;
volatile bit_flag flag3;
volatile bit_flag flag4;
volatile bit_flag gBUART_DATA; 

void Delay_2S(void);
void main(void)
{
    GIE=0;
    CLR_RAM();
    IO_Init();
    ADC_Init();             //ADC
    TIMER0_INT_Init();      //Time0
    TIMER1_INT_Init();      //Time1
    GIE=1;
    ADC_Zero_ADJ();         //ADCУ׼
   	Delay_2S();	   	//ϵʱ2S,صѹȷgBBAT_LEVELȼͬʱȴ·Դȶ

    while (1){
        __asm
        CLRWDT
        __endasm;  
        while(T0IF){
            //10MSѭ
           T0IF=0;
           if(gB500MS_cnt){gB500MS_cnt--;}  //͹ĻѺʹ500MSʱ
            HALL();                         //
            USB();                          //USB
            BAT();                          //BAT
            right_Detect();                 //Ҷ
            left_Detect();                  //
            BAT1_LED();                     //
            UART();                         //ģ⴮ڷ  Baud256000   ͷaa   β55
            STOP();                         //
        }
    }
}
/*********************
*
*--------ж----------
*
**********************/
void int_isr(void) __interrupt
{
__asm 
    movra _abuf
    swapar _PFLAG
    movra _statusbuf
__endasm;
    if((T1IF)&&(T1IE))
   	{
       //100usʱж
        T1IF=0;
   	}

__asm 
    swapar _statusbuf
    movra _PFLAG
    swapr _abuf
    swapar _abuf
__endasm;
}

void Delay_2S(void)
{
    
    while(1)
    {
        __asm
            CLRWDT
        __endasm;
        while(T0IF){
            T0IF = 0;
            gBTime_2S_cnt++;
            ADC_Get_Value_Average(0x0e);    //gWadc_value   ɵصѹ  ͨAN14
            BAT_LEVEL_CHECK();
            if (gBBAT_ADC_VALUE_CNT==0)
            {
                
                if(gBBAT_LEVEL_WAIT==gBBAT_LEVEL)
                {
                    i=0;
                }
                else
                {
                    i++;
                    if(i>=5)
                    {
                        i=0;
                        gBBAT_LEVEL=gBBAT_LEVEL_WAIT;
                    }
                }
                
            }
            
            if(gBTime_2S_cnt>200)
            {
                gBTime_2S_cnt=0;
                goto loop;
            }
        }
    }
loop:
    Nop();
}   