/*****LED****/
#include "MC32P8141.h"
#include "define.h"
#include "Global.h"
void BAT1_LED(void);
void FLASH_LED (void);
u8    gBLED_FLASH_SPEED;
u8    gBLED_DATA_BUF;
u16   gBEAR_MOVE_CNT;
volatile bit_flag gBLED_FLASH_BUF;
volatile bit_flag gBLED_PHY_BUF;
unsigned char   const TAB_EAR_LED[]={
    0x01,0x01,0x01,0x03,0x07,0x0f
};
unsigned char   const TAB_EAR_LED_FLASH[]={
     0x01,0x01,0x01,0x00,0x00,0x00
};
unsigned char   const TAB_BAT_FLASH[]={
     0x01,0x01,0x01,0x02,0x04,0x08
};
unsigned char   const TAB_BAT_FLASH_OFF[]={
     0xfe,0xfe,0xfe,0xfd,0xfb,0xf7
};
/***********صѹӦLEDʾ********/
void BAT1_LED(void)
{
    if(gBEAR_MOVE_CNT){
        gBSTOP_cnt =0;  //
        //gBEAR_MOVE_CNT--;
        gBLED_DATA_BUF = TAB_EAR_LED[gBBAT_LEVEL];
        gBLED_FLASH_BUF.byte = TAB_EAR_LED_FLASH[gBBAT_LEVEL];
    }
    else{
        if(USB_STATUS){
            gBLED_DATA_BUF = TAB_EAR_LED[gBBAT_LEVEL];
            if(BAT_FUll==0)
            gBLED_FLASH_BUF.byte = TAB_BAT_FLASH[gBBAT_LEVEL];

            
        }
    }
    if(gBLED_FLASH_BUF.byte){        
        FLASH_LED();
    }
    gBLED_PHY_BUF.byte = gBLED_DATA_BUF;

    if(LED1_STATUS)
        LED1 = ON;
    else  
        LED1 = OFF;
    if(LED2_STATUS)
        LED2 = ON;
    else  
        LED2 = OFF;
    if(LED3_STATUS)
        LED3 = ON;
    else  
        LED3 = OFF;
    if(LED4_STATUS)
        LED4 = ON;
    else  
        LED4 = OFF;
}
void FLASH_LED (void){
    gBLED_FLASH_SPEED++;
    if (gBLED_FLASH_SPEED>100)
    {
        gBLED_FLASH_SPEED = 0;
    }
    if (gBLED_FLASH_SPEED<50)
    {
        FSR0 = TAB_BAT_FLASH_OFF[gBBAT_LEVEL];
        gBLED_DATA_BUF &= FSR0;
    }
    
    
}
