#include "MC32P8141.h"
#include "define.h"
#include "Global.h"
void UART(void);
void UART_DELAY(void);

void UART(void);
void UART_DELAY(void);
//UARTͻ
__sfr __at 0x70 UART_START;
__sfr __at 0x71 UART_DATA1;
__sfr __at 0x72 UART_DATA2;
__sfr __at 0x73 UART_DATA3;
__sfr __at 0x74 UART_DATA4;
__sfr __at 0x75 UART_DATA5;
__sfr __at 0x76 UART_DATA6;
__sfr __at 0x77 UART_DATA7;
__sfr __at 0x78 UART_DATA8;
__sfr __at 0x79 UART_DATA9;
__sfr __at 0x7A UART_DATAA;
__sfr __at 0x7B UART_DATAB;
__sfr __at 0x7C UART_DATAC;
__sfr __at 0x7D UART_DATAD;
__sfr __at 0x7E UART_DATAE;
__sfr __at 0x7F UART_END;

void UART_DELAY(void){
    Nop();
    Nop();
    Nop();
    Nop();
    Nop();
    Nop();
    Nop();
}
void UART(void){
    UART_START = 0xaa; 
    UART_END = 0x55;
    UART_SEND = 1;
    if(UART_SEND){
        UART_SEND = 0;
       FSR1 = 0;
       FSR0 = 0x70;
        GIE = 0;
        while(1){
            __asm
            CLRWDT
            __endasm;
            

            gBUART_DATA.byte = INDF0;
            UART_IO = 0;
            Nop();
            UART_DELAY();
            if(UART_BIT0){
                Nop();
                UART_IO = 1;
                //Nop();
            }
            else{
                //Nop();
                UART_IO = 0;
                Nop();
            }
            UART_DELAY();
            if(UART_BIT1){
                Nop();
                UART_IO = 1;
                //Nop();
            }
            else{
                //Nop();
                UART_IO = 0;
                Nop();
            }
            UART_DELAY();
            if(UART_BIT2){
                Nop();
                UART_IO = 1;
                //Nop();
            }
            else{
                //Nop();
                UART_IO = 0;
                Nop();
            }
            UART_DELAY();
            if(UART_BIT3){
                Nop();
                UART_IO = 1;
                //Nop();
            }
            else{
                //Nop();
                UART_IO = 0;
                Nop();
            }
            UART_DELAY();
            if(UART_BIT4){
                Nop();
                UART_IO = 1;
                //Nop();
            }
            else{
                //Nop();
                UART_IO = 0;
                Nop();
            }
            UART_DELAY();
            if(UART_BIT5){
                Nop();
                UART_IO = 1;
                //Nop();
            }
            else{
                //Nop();
                UART_IO = 0;
                Nop();
            }
            UART_DELAY();
            if(UART_BIT6){
                Nop();
                UART_IO = 1;
                //Nop();
            }
            else{
                //Nop();
                UART_IO = 0;
                Nop();
            }
            UART_DELAY();
            if(UART_BIT7){
                Nop();
                UART_IO = 1;
                //Nop();
            }
            else{
                //Nop();
                UART_IO = 0;
                Nop();
            }
            UART_DELAY();
            Nop();
            Nop();
            UART_IO = 1;
            FSR0++;
            if (FSR0>0x7f)
            {
                goto    DD;
            }
            
        }
DD:
        GIE = 1;
        
    }
}