/*****ʼ********/
#include "MC32P8141.h"
#include "define.h"
#include "Global.h"
void ADC_Init(void);
void CLR_RAM(void);
void IO_Init(void);
void TIMER0_INT_Init(void);
void TIMER1_INT_Init(void);
//void TIMER2_INT_Init(void);

/************************************************
;  *    @Function Name       : CLR_RAM
;  *    @Description         :  
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void CLR_RAM(void)
{
__asm
    movai 0x7F 
    movra FSR0
    clrr INDF0
    DJZR FSR0 
    goto $-2 
    clrr INDF0
__endasm;
    
}
/************************************************
;  *    @Function Name       : IO_Config
;  *    @Description         : ioڳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void IO_Init(void)
{
    //BIT0 -- BIT7ʵֿλ
    //ioڷ  P00-P03P05    1:out  0:in
    OEP0 = (BIT7); 
    //ioλ
    IOP0 = (0); 
    //io   1:enable  0:disable
    PUP0 = (BIT4+BIT6); 
    //P03 P00
    DRVCR = (BIT3+BIT2); 
    //io   1:enable  0:disable
    PDP0 = (BIT3+BIT0); 

    //ioڷ  P12-P15    1:out  0:in
    OEP1 = (BIT1+BIT2+BIT3+BIT4+BIT5+BIT7); 
    //ioλ
    IOP1 = (BIT2+BIT3+BIT4+BIT5+BIT7); 
    //io   1:enable  0:disable
    PUP1 = (BIT0); 
    //io   1:enable  0:disable
    PDP1 = (0); 
     //˿ģ  P01-P02ģ 1:ģ  0:
    P0ADCR = (BIT2+BIT1);
    //˿ģ  P16ģ     1:ģ  0:
    P1ADCR = (BIT6); 

   
}
/************************************************
;  *    @Function Name       : ADC_Init
;  *    @Description         : ADCʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void ADC_Init(void)
{
    ADCR0 = 0xf0; //ʹADC256Ƶ
    ADCR1 = 0xb0; //12λH8L4ڲ2V15ADCLK
}

/************************************************
;  *    @Function Name       : TIMER0_INT_Init
;  *    @Description         : ʱʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void TIMER0_INT_Init(void)
{
    T0CR    =   0x02; //ʱģʽʱΪFHOSCƵ
    T0CNTH  =   0x27;
    T0CNTL  =   0x10;     
    T0LOADH =   0x27;
    T0LOADL =   0x10;
    T0EN    =   1;
    
}
 /************************************************
 ;  *    @Function Name       : TIMER1_INT_Init
 ;  *    @Description         : ʱʼ
 ;  *    @IN_Parameter        :`
 ;  *    @Return parameter    :
 ;  ***********************************************/
void TIMER1_INT_Init(void)
{
     T1CR = 0x02;  	    //ʱΪFCPU4Ƶ
     T1CNT = 100;
     T1LOAD = 100; 	    //100uS
     T1EN=1;            //ʹT1
     T1IE = 1;
}

// void TIMER2_INT_Init(void)
// {
//      T12CR = 0x03;  	//رPWMʱΪFCPU8Ƶ
//      T2CNT = 100;
//      T2LOAD = 100;  	   	//100uS
//      T2EN=1;            //ʹT2
//      T2IE = 1;
//  }
