#define u8  unsigned char
#define u16 unsigned int
#define u32 unsigned long int
#define uint8_t  unsigned char
#define uint16_t unsigned int
#define uint32_t unsigned long int
#define	   	   	BIT0   	   	   	0x01
#define	   	   	BIT1   	   	   	0x02
#define	   	   	BIT2   	   	   	0x04
#define	   	   	BIT3   	   	   	0x08
#define	   	   	BIT4   	   	   	0x10
#define	   	   	BIT5   	   	   	0x20
#define	   	   	BIT6   	   	   	0x40
#define	   	   	BIT7   	   	   	0x80
/*****************************************/
//----------------------------------/
//--------ֳ
enum{
	BAT_standby,
	charge,
	BAT_full
};
//--------
enum{
	standby,		//==0
	discharge,
	full,
	over_cur,
	short_CUR,
	send_pluse,
	low_stop,
	ntc_stop
};
#define	FAIL 1
#define PASS 0
/***********ƿؿ----*/
#define	OFF 1
#define ON 0
/******IO*****/
#define L_EAR_IO    P00D
#define R_EAR_IO    P03D
#define HALL_IO    	P04D   	   	   	   	   	   	//IO忽
#define USB_IO    	P06D   	   	   	   	   	   	//USB IO
#define	LED1		P12D
#define	LED2		P13D
#define	LED3		P14D
#define	LED4		P15D
#define	EAR_5V		P17D
#define	UART_IO		P07D

//--------ADCͨ----
#define  GND        0x0f
#define  VDD        0x0E
#define  L_EAR      0x0A
#define  R_EAR      0x09
/***********/
#define 	 CUR_7MA    	   	14
#define 	 CUR_150MA    	   	307
#define 	 CUR_300MA    	   	614


/*******ص*******/
#define    	ADC100     	   	   	2088
#define    	ADC75  	   	       	1945
#define    	ADC50  	   	       	1843
#define    	ADC25  	   	       	1740            //׼2Vͨ1/4VDD   ɵ ѹֵ/4/2*4096
#define    	HALL_shake_data     30 	   	   	   	//
#define    	USB_shake_data      30 	   	   	   	//USb
#define    	left_shake_data     30 	   	   	   	//
#define    	USB_MOVE_ADC_VALUE	0x0600			//USBߺѹs

//============Define  Flag=================
typedef union {
   	unsigned char byte;
   	struct
   	{
   	   	u8 bit0 : 1;
   	   	u8 bit1 : 1;
   	   	u8 bit2 : 1;
   	   	u8 bit3 : 1;
   	   	u8 bit4 : 1;
   	   	u8 bit5 : 1;
   	   	u8 bit6 : 1;
   	   	u8 bit7 : 1;
   	} bits;
}bit_flag;
extern volatile bit_flag flag1;
extern volatile bit_flag flag2;
extern volatile bit_flag flag3;
extern volatile bit_flag flag4;
extern volatile bit_flag gBUART_DATA;
extern volatile bit_flag gBLED_PHY_BUF;
extern volatile bit_flag gBLED_FLASH_BUF;
#define    	UART_Stop_TX_FLAG  	flag1.bits.bit0	   	 
#define     left_ON	   	   	   	flag1.bits.bit1
#define     right_ON   	   	   	flag1.bits.bit2
#define    	T2_50ms     	   	flag1.bits.bit3
#define   	LEAR_ON 	   	   	flag1.bits.bit4
#define   	LEAR_OUT     	   	flag1.bits.bit5
#define    	HALL_ON     	   	flag1.bits.bit6
#define    	HALL_OFF        	flag1.bits.bit7

#define    	HALL_STATUS         flag2.bits.bit0
#define    	USB_STATUS          flag2.bits.bit1
#define    	USB_ON         		flag2.bits.bit2
#define    	USB_OFF         	flag2.bits.bit3
#define    	BAT_FUll         	flag2.bits.bit4
#define    	BAT_Remove         	flag2.bits.bit5
#define    	BAT_Low         	flag2.bits.bit6
#define    	BAT_Low_OFF         flag2.bits.bit7

#define    	left_keep_check     flag3.bits.bit0
#define    	left_FULL     		flag3.bits.bit1
#define    	right_FULL     		flag3.bits.bit2
#define    	right_keep_check    flag3.bits.bit3
#define    	bat_low_off_flag    flag3.bits.bit4 
#define    	bat_low_tip_flag    flag3.bits.bit5
#define   	REAR_ON 	   	   	flag3.bits.bit6
#define   	REAR_OUT     	   	flag3.bits.bit7

#define    	R_EAR_5V     		flag4.bits.bit0
#define    	L_EAR_5V     		flag4.bits.bit1
#define    	OUT_5V     			flag4.bits.bit2
#define    	UART_SEND     		flag4.bits.bit3
#define    	BAT_Recharge     	flag4.bits.bit4
#define    	left_pulse     		flag4.bits.bit5				//־λ
#define    	right_pulse     	flag4.bits.bit6				//Ҷ־λ

#define    	UART_BIT0     		gBUART_DATA.bits.bit0
#define    	UART_BIT1     		gBUART_DATA.bits.bit1
#define    	UART_BIT2     		gBUART_DATA.bits.bit2
#define    	UART_BIT3    		gBUART_DATA.bits.bit3
#define    	UART_BIT4    		gBUART_DATA.bits.bit4
#define    	UART_BIT5    		gBUART_DATA.bits.bit5
#define   	UART_BIT6 	   	   	gBUART_DATA.bits.bit6
#define   	UART_BIT7     	   	gBUART_DATA.bits.bit7

#define    	LED1_STATUS         gBLED_PHY_BUF.bits.bit0
#define    	LED2_STATUS         gBLED_PHY_BUF.bits.bit1
#define    	LED3_STATUS         gBLED_PHY_BUF.bits.bit2
#define    	LED4_STATUS        	gBLED_PHY_BUF.bits.bit3

#define    	LED1_FLASH          gBLED_FLASH_BUF.bits.bit0
#define    	LED2_FLASH          gBLED_FLASH_BUF.bits.bit1
#define    	LED3_FLASH         	gBLED_FLASH_BUF.bits.bit2
#define    	LED4_FLASH         	gBLED_FLASH_BUF.bits.bit3

